#include "Cam.h"
#include "My_main.h"
Tag_struct Tag;
PTZ_struct PTZ;
/**********************************
 **函数名:PTZ_control
 **作用 :控制云台

************************************/
u8 PTZ_control(s16 Angle1,s16 Angle2)
{
		unsigned char tempBuff[4]={0x4e,0x56,0x00,0x00};

		
		//限幅
		if(Angle1<20)	Angle1 =20;						//105	为中心		向左增大
		if(Angle1>180)	Angle1 =180;				
		if(Angle2<48)	Angle2 =48;						//90°向前，向上增大
		if(Angle2>112)	Angle2 =112;				//48°停机坪

		
		
				tempBuff[2]=(u8)Angle1;
				tempBuff[3]=(u8)Angle2;
				DrvUart3SendBuf(tempBuff,4);
		
		
		return 1;
}


/**********************************
 **函数名:PTZ_Shot
 **作用 :控制云台,点射激光

************************************/
u8 PTZ_Shot()
{
	float err_x,err_y;
	static u32 LastControlTime;
	static float Lasterr_x,Lasterr_y;


		if(time_dly_cnt_ms-LastControlTime <50){		//间隔太短不发送
			
			return 0;
			
	}
	LastControlTime =time_dly_cnt_ms;	
	
	if(Tag.Scan_IfNoPhoto){
		Tag.Scan_IfNoPhoto =0;
		LIGHT =1;
		err_x = Tag.X*0.2f +(Tag.X-Lasterr_x)*0.01f;
		err_y = Tag.Y*0.15f+(Tag.Y-Lasterr_y)*0.015f;
		
		Lasterr_x =Tag.X;
		Lasterr_y =Tag.Y;
		if(err_x>4.0f)	err_x =4.0f;	//限幅
		else if(err_x<-4.0f) err_x =-4.0f;	//限幅
		if(err_y>4.0f)	err_y =4.0f;	//限幅		
		else if(err_y<-4.0f) err_y =-4.0f;	//限幅
		PTZ.Angle2 += err_x;
		PTZ.Angle1 -= err_y;	
				
		//限幅
		if(PTZ.Angle1<10)	PTZ.Angle1 =10;						//40°为中心		向左增大
		if(PTZ.Angle1>170)	PTZ.Angle1 =170;				
		if(PTZ.Angle2<48)	PTZ.Angle2 =48;						//90向前			
		if(PTZ.Angle2>112)	PTZ.Angle2 =112;		

//		USRDate2 =(s16)LastAngle2;
//		USRDate3 =(s16)LastAngle1;		
		//完成矫正
//		if(s16abs(Tag.X,0)<10 && s16abs(Tag.Y,0)<10){
//			LIGHT =3;
//			RecolletIfNo =1;
//			return 0;
//		}
		
		return (PTZ_control(PTZ.Angle1,PTZ.Angle2));
	}
	else LIGHT =0;
	return 0;
}


#define PTZ_MINAngle1 10
#define PTZ_MAXAngle1 170
#define PTZ_MINAngle2 48
#define PTZ_MAXAngle2 60

/**********************************
 **函数名:PTZ_AllAngleScan
 **作用 :舵机全角度搜索
************************************/
u8 PTZ_AllAngleScan()
{
	static s16 LastAngle1=PTZ_MINAngle1,LastAngle2=PTZ_MINAngle2;
	static char DirAngle1=1,DirAngle2=1;
	
	
	LastAngle1+=1*DirAngle1;
	if(LastAngle1>PTZ_MAXAngle1){
		DirAngle1	=-1;
		LastAngle2+=4*DirAngle2;
	}
	else if(LastAngle1 <PTZ_MINAngle1){
		DirAngle1 =1;
		LastAngle2+=3*DirAngle2;
	}
	
	if(LastAngle2>PTZ_MAXAngle2){
		DirAngle2 =-1;
	}
	else if(LastAngle2 <PTZ_MINAngle2){
		DirAngle2 =1;
	}
	//更新ptz
	PTZ.Angle1=LastAngle1;
	PTZ.Angle2=LastAngle2;
	
	
	PTZ_control(LastAngle1,LastAngle2);
	LIGHT =0;
	return 1;
}

/**********************************
 **函数名:PTZ_FindTarge
 **作用 :云台搜索目标，完成矫正返回1
************************************/
u8 PTZ_FindTarge()
{
	static u32 Dt;
	if(Tag.Scan_IfNoPhoto ==1){
		
		PTZ_Shot();	//激光笔矫正
		Dt =time_dly_cnt_ms;
		LIGHT =1;
	}
//	else if(time_dly_cnt_ms -Dt >4000)
//		PTZ_AllAngleScan();//全角度激光笔扫描
	else LIGHT =0;
	
	return 0;
}


/**********************************
 **函数名:K210_Tag_Solve
 **作用 :解算火情监测k210接收数据
 **输入:
 **返回值:
************************************/
void K210_Tag_Solve()
{
		static float TagXYCol[2][10]={0};
		static s16 x=0;
		
		Tag.Num =STC_originRxBuff[2];
		Tag.Z =-112 +STC_originRxBuff[5];
		if(Tag.Analysis_IfNoPhoto ==1){					//识别到
					Tag.Analysis_IfNoPhoto =0;
					STC_originRxBuff[0] =0x00;				//防止电磁干扰
					TagXYCol[0][x]	=-112+STC_originRxBuff[3];		
					TagXYCol[1][x]	=-112+STC_originRxBuff[4];		
			
					if(floatabs(TagXYCol[0][x],Tag.X)>60.0f)		TagXYCol[0][x] =0.2f*TagXYCol[0][x]+0.5f*TagXYCol[0][(x+9)%10];	//防震荡
					if(floatabs(TagXYCol[1][x],Tag.Y)>60.0f)		TagXYCol[1][x] =0.2f*TagXYCol[1][x]+0.5f*TagXYCol[1][(x+9)%10];	//防震荡
			
					if(TagXYCol[0][x]>112)	TagXYCol[0][x]	=112;					
					else if(TagXYCol[0][x]<-112)	TagXYCol[0][x]	=-112;	
					
					if(TagXYCol[1][x]>112)	TagXYCol[1][x]	=112;					
					else if(TagXYCol[1][x]<-112)	TagXYCol[1][x]	=-112;	
					
		}	
		else {																//没事别到
			TagXYCol[0][x]	=0.98f*TagXYCol[0][(x+9)%10];
			TagXYCol[1][x]	=0.98f*TagXYCol[1][(x+9)%10];		
			
		}

		Tag.X =	(s16)(0.5f*(TagXYCol[0][x]	+TagXYCol[0][(x+9)%10] +TagXYCol[0][(x+8)%10])/3 +
								0.3f*(TagXYCol[0][(x+7)%10]	  +TagXYCol[0][(x+6)%10] +TagXYCol[0][(x+5)%10])/3 +
								0.2f*(TagXYCol[0][(x+4)%10]	  +TagXYCol[0][(x+3)%10] +TagXYCol[0][(x+2)%10]+TagXYCol[0][(x+1)%10])/4);

		Tag.Y =	(s16)(0.5f*(TagXYCol[1][x]	+TagXYCol[1][(x+9)%10] +TagXYCol[1][(x+8)%10])/3 +
								0.3f*(TagXYCol[1][(x+7)%10]	  +TagXYCol[1][(x+6)%10] +TagXYCol[1][(x+5)%10])/3 +
								0.2f*(TagXYCol[1][(x+4)%10]	  +TagXYCol[1][(x+3)%10] +TagXYCol[1][(x+2)%10]+TagXYCol[1][(x+1)%10])/4);	
		x++;
		x%=10;

}
