//声明：
//部分展示，引用开源代码与实验室代码，部分不外传


#include "User_Task.h"
#include "Drv_RCIn.h"
#include "LX_FC_Fun.h"
#include "ANO_DT_LX.h"
#include "light.h"
#include "My_main.h"



//左杆上：自稳加定高
//左杆中：定点
//左杆下：程控

/**********************************
左三档杆要推到中间，为设置定点模式
右三档杆推到下面，为启动程序模式
************************************/

void UserTask_OneKeyCmd(void)
{
    //////////////////////////////////////////////////////////////////////
    //一键起飞/降落例程
    //////////////////////////////////////////////////////////////////////
    //用静态变量记录一键起飞/降落指令已经执行。
    static u8 one_key_takeoff_f = 1, one_key_land_f = 1, one_key_mission_f = 0;
    static u8 mission_step;
    //判断有遥控信号才执行
    if (rc_in.no_signal == 0)
    {
        //判断第6通道拨杆位置 1300<CH_6<1700																										//右杆中
        if (rc_in.rc_ch.st_data.ch_[ch_6_aux2] > 1300 && rc_in.rc_ch.st_data.ch_[ch_6_aux2] < 1700)
        {
            //还没有执行
            if (one_key_takeoff_f == 0)
            {
                //标记已经执行
                one_key_takeoff_f = OneKey_Takeoff(100);	//执行一键起飞			//参数单位：厘米； 0：默认上位机设置的高度。
            }
        }
        else
        {
            //复位标记，以便再次执行
            one_key_takeoff_f = 0;
        }
        //
        //判断第6通道拨杆位置 800<CH_6<1200																												//右杆上
        if (rc_in.rc_ch.st_data.ch_[ch_6_aux2] > 800 && rc_in.rc_ch.st_data.ch_[ch_6_aux2] < 1200)
        {
            //还没有执行
            if (one_key_land_f == 0)
            {
							//将所有方向速度清零，准备降落
							Hover();							
							//标记已经执行
              one_key_land_f = OneKey_Land();		//执行一键降落
            }
        }
        else
        {
            //复位标记，以便再次执行
            one_key_land_f = 0;
        }
				//判断第6通道拨杆位置 1700<CH_6<2200 
				//应该dui'ying
				if((rc_in.rc_ch.st_data.ch_[ch_6_aux2]>1700 && rc_in.rc_ch.st_data.ch_[ch_6_aux2]<2200) /*&& Car.Go ==1*/)		//右杆下或小车下达发车
				{
					//还没有执行
					if(one_key_mission_f ==0)
					{
						//标记已经执行
						one_key_mission_f = 1;
						//开始流程
						mission_step = 1;
					}
				}
				else
				{
					//复位标记，以便再次执行
					one_key_mission_f = 0;		
				}
				//
				if(one_key_mission_f==1)
				{
					
					
/***************用户进程***************/					
					Process_polling(mission_step);
					KeepMagAngle(MagKeepFlag,MagKeepAngle);//地磁固定角度
/**************************************/
					
					
					
				}
				else	//复位内容
				{
					mission_step = 0;
					Process_Init();			//复位初始化
				}
		}
    ////////////////////////////////////////////////////////////////////////



#include "process.h"
#include "light.h"
#include "Drv_Uart.h"
#include "Fire_task.h"
#include "Parking_task.h"
#include "My_main.h"
#include "Special2023.h"



char whats_taskIsNow =0;
u32 time_dly_cnt_ms = 0;

/**********************************
 **函数名:Process_Init
 **作用 :复位初始化
************************************/
u8 Process_Init()
{
	
	whats_taskIsNow =Take_offPlane;
	Parking_structInit();//停机坪初始化
	Fire_structInit();	//火情初始化
	
	return 0;
}



/**********************************
 **函数名:Process_polling
 **作用 :总进程
 **输入:是否执行
 **返回值:如果执行完毕返回1，否则为0
************************************/
void Process_polling(u8 InitIfNo)
{
	static int step1 =0;
	static int UWBMapStep =0;
	
	if(InitIfNo ==0)	//未初始化
		return;
	
	
	
	
//起飞	
			if(whats_taskIsNow == Take_offPlane ){
				if(step1 ==0){
					//切换定点模式
					step1+=LX_Change_Mode(2);			//2
				}
				if(step1 ==1){				
					//解锁
					step1+=FC_Unlock();			
				}
				if(step1 ==2){				
					//地磁初始化
					step1+=IMU_MagInit();			
				}				
				if(step1 ==3 && My_MsTimer(2000) ==1){	//这段延迟必须加，有点古怪
					step1 ++;
				}
				if(step1 ==4){
					step1+=OneKey_Takeoff(180);
				}
				
				if(step1 ==5 && My_MsTimer(3500) ==1){
						MagKeepFlag =1;		//开启地磁角度矫正
						MagKeepAngle =0;					
					step1 ++;	
				}
				if(step1 ==6 /*&& dXY_correct() ==1*/){			//中心矫正
					whats_taskIsNow =Proc2023;				//时间的尽头*****
					step1 =0;				
				}
			}

//2023程序
			if(whats_taskIsNow ==Proc2023){
					if(TotalProcess2023Base()==1){
						whats_taskIsNow =Take_downPlane;
					}
			}	











			
////摄像头误差记录
//			if(whats_taskIsNow ==XY_correct){
//					LIGHT =3;
//					if(dXY_correct()==1){
//						whats_taskIsNow =Find_Parking_lot;
//					}
//			}				
			
////UWB测试
//			if(whats_taskIsNow ==test){
//				LIGHT =UWBMapStep;
//				if(step1 ==0){
//						if(UWBGoWithMap(UWBMapStep)==1){
//							UWBMapStep++;
//							if(UWBMapStep==1){
//								step1 ++;
//							}
//						}
//					
////			step1 +=UWB_OneKeyToPosition(2500,2000);				
//				}
//					
//				else if(step1 ==1){
//					whats_taskIsNow = Find_Parking_lot;
//					step1=0;
//				}
//			}


//			


////2021程序
//			if(whats_taskIsNow ==Proc2021){
//					if(TotalProcess2021()==1){
//						whats_taskIsNow =Find_Parking_lot;
//					}
//			}		


			
////寻找火源			
//			if(whats_taskIsNow == Find_Fire){
//					if(Fire_process() ==1){
//							whats_taskIsNow =Find_Parking_lot/*Take_downPlane*/;
//					
//					}
//			
//			}
//			
//			
//			
//寻找停机坪
//			if(whats_taskIsNow == Find_Parking_lot){				
//				if(Parking_process() ==1){
//					//whats_taskIsNow =Take_downPlane;
//					step1 =0;
//				}
//			}
			
//降落
			if(whats_taskIsNow == Take_downPlane){	
				if(step1 ==0){
						Hover();
						step1 ++;
				}
					
				else if(step1 ==1){
					//执行一键降落						
					if(OneKey_Land() ==1)
					whats_taskIsNow =NoTask;
					step1 =0;
				}					
			}




////雷达测试
//			if(whats_taskIsNow ==test){
//				if(step1 ==0){
//					K210TargeMode1 =0x01;		
//					if(K210Mode == 0x01)					
//						step1 ++;
//					LIGHT =1;
//				}
//				else if(step1 ==1){
//						step1 +=SetScanAngle(-70,70);		//前方检测
//						MagKeepFlag =1;
//				}
//					
//				else if(step1 ==2){
//						step1+=LadarGoToHead(80,0,50);	//雷达定头矫正 目标距离 起始角度 起始距离
//					//step1+=	LadarHeadRotate(90,80,100,-15);			//公旋转
//					//step1 +=LadarTurn(0,5,90,100);				//自传
//					//step1+=CircularMotion(20,80,0.5);	//开环公转
//				}
//					
//				else if(step1 ==3){
//					whats_taskIsNow = Take_downPlane;
//					step1=0;
//				}
//					
//			}		

//地磁测试
//			if(whats_taskIsNow ==test){
//				if(step1 ==0){
//						step1+=turn(30,3000);
//				}
//					else if(step1 ==1){
//					step1 +=MagToAngle(0);
//					}
//				else if(step1 ==2){
//					whats_taskIsNow = Take_downPlane;
//				}
//			
//			}


////转动综合小测试
//			if(whats_taskIsNow ==test){
//				USRDate3 =step1;
//				if(step1 ==0){			
//						step1 +=feet(25,0,0,3000);

//				}				
//				else if(step1 ==1){			
//						step1 +=feet(0,-25,0,4000);

//				}
//				else if(step1 ==2){
//					K210TargeMode1 =0x01;		
//					if(K210Mode == 0x01)					
//						step1 ++;
//						LIGHT =1;
//				}

//				else if(step1 ==3){			
//						step1 +=LadarTurn(0,3,90,100);

//				}
//				else if(step1 ==4){
//						step1 +=SetScanAngle(-70,70);		//前方检测
//				}
//				else if(step1 ==5){			
//						step1 +=LadarHeadRotate(360,80,100,15);
//					//step1+=	LadarHeadRotate(90,80,100,-15);			//公旋转
//					//step1 +=LadarTurn(0,5,90,100);				//自传
//					//step1+=CircularMotion(20,80,0.5);	//开环公转
//				}				
//				else if(step1 ==6){
//						LIGHT =1;
//						step1 +=MagToAngle(0);
//				}
//				else if(step1 ==7){
//						step1 +=feet(-25,25,0,3000);
//				}
//				
//				else if(step1 ==8){
//					whats_taskIsNow = Find_Parking_lot;
//					step1=0;
//				}
//					
//			}		

////摄像头直角矫正测试
//			if(whats_taskIsNow ==test){
//				if(step1 ==0){
//						K210TargeMode1 =0x04;	//寻仙模式	
//						step1 ++;
//				}
//					else if(step1 ==1){
//					step1 +=Parking_process();
//					}
//				else if(step1 ==2){
//					whats_taskIsNow = Take_downPlane;
//				}
//			
//			}


			if(whats_taskIsNow ==test){
					if(step1 ==0){
							step1 +=feet(0,0,-40,2000);
					}
					if(step1 ==1){
						LIGHT =2;
						step1 +=feet(0,0,-0,2000);
					}
					if(step1 ==1){
						whats_taskIsNow =Take_downPlane;
						step1 =0;
						
					}					
			}



            #include "Special2023.h"


u8 TotalProcess2023Base()
{
	static char Step1=0;
	
	UWB.Landmark_flag =1;	//UWB里程累计
	LIGHT =1;
	
	K210TargeMode3 =1;
	//地磁控制
	MagKeepFlag =1;
	MagKeepAngle =0;	
	
	if(Step1 ==0 &&UWBGoWithMap(0,Car.task) ==1){		//1号点
		Step1 ++;
		
		
	}
	else if(Step1 ==1){											//识别
		if(Car.task ==0){
			Step1 ++;
		}
		else {
			Step1 +=Parking_process();
		}
		
	}
	
	
	else if(Step1 ==2 &&UWBGoWithMap(1,Car.task) ==1){		//2号点
		
		Step1 ++;
		
	}
	else if(Step1 ==3){											//识别
		if(Car.task ==0){
			Step1 ++;
		}
		else {
			Step1 +=Parking_process();
		}
	}
	
	else if(Step1 ==4 &&UWBGoWithMap(2,Car.task) ==1){		//3号点	
		Step1 ++;	
	}
	else if(Step1 ==5){													//识别
		if(Car.task ==0){
			Step1 ++;
		}
		else {
			Step1 +=Parking_process();
		}
	}		
	
	else if(Step1 ==6 &&UWBGoWithMap(3,Car.task) ==1){		//4号点
		Step1 ++;
		
	}	
	else if(Step1 ==7){											//识别
		if(Car.task ==0){
			Step1 ++;
		}
		else {
			Step1 +=Parking_process();
			
		}
	}		

	else if(Step1 ==8 &&UWBGoWithMap(4,Car.task) ==1){		//4号点
		Step1 ++;
		
	}	
	else if(Step1 ==9){											//识别
		if(Car.task ==0){
			Step1 ++;
		}
		else {
			Step1 +=Parking_process();
		}
	}		

	
	else if(Step1 ==10 &&UWBGoWithMap(5,Car.task) ==1){		//5号点
		Step1 ++;
	}		
	else if(Step1 ==11){											//识别
		if(Car.task ==0){
			Step1 ++;
		}
		else {
			Step1 +=Parking_process();
		}
	}		
	else if(Step1 ==12 &&UWBGoWithMap(6,Car.task) ==1){		//6号点
		Step1 ++;
		
	}
	else if(Step1 ==13){											//识别
		if(Car.task ==0){
			Step1 ++;
		}
		else {
			Step1 +=Parking_process();
		}
	}		
	else if(Step1 ==14 &&UWBGoWithMap(7,Car.task) ==1){		//家
			Step1 ++;
	}
	else if(Step1 ==15){											//识别
		if(Car.task ==0){
			Step1 ++;
		}
		else {
			return 1;
		}
	}		
		else if(Step1 ==16 &&UWBGoWithMap(8,Car.task) ==1){		//家
			Step1 ++;
	}
	else if(Step1 ==17){											//识别
		if(Car.task ==0){
			Step1 ++;
		}
		else {
			Step1 +=Parking_process();
		}
	}		
		else if(Step1 ==18 &&UWBGoWithMap(9,Car.task) ==1){		//家
			Step1 ++;
	}
	else if(Step1 ==19){											//识别
		if(Car.task ==0){
			Step1 ++;
		}
		else {
			Step1 +=Parking_process();
		}
	}		
		else if(Step1 ==20 &&UWBGoWithMap(10,Car.task) ==1){		//家
			Step1 ++;
	}
	else if(Step1 ==21){											//识别
		if(Car.task ==0){
			Step1 ++;
		}
		else {
			Step1 +=Parking_process();
		}
	}		
	
	else if(Step1 ==22 &&UWBGoWithMap(11,Car.task) ==1){		//家
		Step1 =0;
		return 1;
	}	

	return 0;
	
}







}


}


